/*
 * Copyright 2005-2010 the original author or authors.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */ 
package org.wamblee.test.persistence.toplink;

import java.io.File;
import java.util.Map;

import org.dbunit.dataset.filter.ITableFilterSimple;
import org.wamblee.io.FileSystemUtils;
import org.wamblee.test.persistence.JpaCustomizer;
import org.wamblee.test.persistence.PersistenceUnitDescription;

/**
 * 
 * @author $author$
 * @version $Revision$
 */
public class ToplinkJpaCustomizer implements JpaCustomizer {
    /**
     * Creates a new ToplinkJpaCustomizer object.
     */
    public ToplinkJpaCustomizer() {
        // Empty
    }

    @Override
    public void customize(PersistenceUnitDescription aPersistenceUnit,
        Map<String, String> aJpaProperties) {

        // Custom datasource properties.
        aJpaProperties.put("toplink.jdbc.url", aJpaProperties.get("javax.persistence.jdbc.url"));
        aJpaProperties.put("toplink.jdbc.user", aJpaProperties.get("javax.persistence.jdbc.user"));
        aJpaProperties.put("toplink.jdbc.password", aJpaProperties.get("javax.persistence.jdbc.password"));

        // DDL generation for toplink
        aJpaProperties.put("toplink.ddl-generation", "drop-and-create-tables");
        
        // DDL generation
        FileSystemUtils.createDir(new File("target/sql"));
        aJpaProperties.put("toplink.create-ddl-jdbc-file-name", "target/sql/create-schema.sql");
        aJpaProperties.put("toplink.drop-ddl-jdbc-file-name", "target/sql/drop-schema.sql");
    }

    @Override
    public ITableFilterSimple getJpaTables() {
        return new ToplinkTables();
    }
}
